Concept
BidirectionalIteratorConcept
Iterator that can be both incremented and decremented.

CopyConstructibleConcept | EqualityComparableConcept | IteratorAssociatedTypesConcept

DefaultConstructibleConcept | InputIteratorConcept

ForwardIteratorConcept

BidirectionalIteratorConcept

MutableRandomAccessIteratorConcept | RandomAccessIteratorConcept

RootedRandomAccessIteratorConcept

MutableRootedRandomAccessIteratorConcept

Concept Definition
Refines
ForwardIteratorConcept
Required Metafunctions

Difference | Type of an object that stores the difference between two iterators. (IteratorAssociatedTypesConcept)
GetValue | Type for reading values. (IteratorAssociatedTypesConcept)
Pointer | Returns pointer to an object, required for operator->, for example. (IteratorAssociatedTypesConcept)
Reference | Reference type. (IteratorAssociatedTypesConcept)
Value | Type of the items in the container or behind an iterator. (IteratorAssociatedTypesConcept)

Required Functions

goNext | Iterates to next position. (ForwardIteratorConcept)
goPrevious | Iterates to pevious position.
operator* | C++ built-in multiplication operator. (InputIteratorConcept)
operator++ (prefix) | C++ built-in prefix increment operator. (InputIteratorConcept)
operator++ (suffix) | C++ built-in suffix increment operator. (InputIteratorConcept)
operator-> | C++ built-in structure dereference operator. (InputIteratorConcept)
operator-- (prefix) | C++ built-in prefix decrement operator.
operator-- (suffix) | C++ built-in suffix decrement operator.

Refinements

MutableRandomAccessIteratorConcept | A RandomAccessIteratorConcept that allows assignable derefentiation.
RandomAccessIteratorConcept | An iterator allowing random access.

BidirectionalIteratorConcept<T>
Include Headers
seqan/basic.h
Remarks
The SeqAn iterators mirror the definitions from ConceptC++.
Implemented by

ModifiedIterator | Allows to modify arbitrary iterators by specializing what differs from an origin. (RandomAccessIteratorConcept)

Used By Function
goPrevious, getValue, value, goNext
Functions

getValue | Access to the value. (IteratorAssociatedTypesConcept)
goNext | Iterates to next position. (ForwardIteratorConcept)
value | Reference to the value. (IteratorAssociatedTypesConcept)

Examples
In the following, x is an iterator to type X.
The following expressions must be valid.
--x // Predecrement.
x-- // Postdecrement.
SeqAn - Sequence Analysis Library - www.seqan.de

Page built @2014/10/13 16:12:57